/*
 * g_plot.c - api for creating files viewable by gnuplot
 *
 * author: hackbard@hackdaworld.dyndns.org
 *
 */

#define _GNU_SOURCE
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "g_plot.h"

int gp_init(char *f_name) {
 int fd;
 if((fd=open(f_name,O_WRONLY|O_CREAT))<0)
  printf("failed to open file: %s\n",f_name);
 return fd;
}

int gp_add_data(int fd,void *data,int x_c,int y_c,int type) {
 int x,y;
 /* we need pointers */
 for(y=0;y<y_c;y++) {
  for(x=0;x<x_c;x++) {
   if(type==TYPE_INT)
    dprintf(fd,"%d ",*(((int *)data)+y*x_c+x));
   if(type==TYPE_DOUBLE)
    dprintf(fd,"%f ",*(((double *)data)+y*x_c+x));
  }
  dprintf(fd,"\n");
 }
 return 1;
}

int gp_close(int fd) {
 return(close(fd));
}
